'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: June 15, 2004
'
'Thanks to NETMaster, and Brian Low for the DShowNET and DirectX.Capture libraries.
'Special thanks to Blas5 from which this frame capture code is based.
'The Code Project
'http://www.codeproject.com/directx/CapSample1.asp
'
' FTP code reference http://www.ftpplanet.com/ftpresources/ftp_codes.htm
'=============================================

Imports DirectX.Capture
Imports System
Imports System.IO

Public Module General

    Public Structure Active
        Dim Camera As Filter
        Dim CaptureInfo As Capture
    End Structure

    'Global variables definition

    Public CaptureInformation As Active
    Public Dispositivos As New Filters()
    Private mobjImage As Image = Nothing
    Private mobjDelayTimer As Timer
    Private mblnConsoleOut As Boolean = True

    Public Const KEYPATH As String = "Software\CBX\Apps\WamPosterCL"

    Friend Sub Writeline(ByVal Text As String)
        If mblnConsoleOut Then Console.WriteLine(Text)
    End Sub

    <STAThread()> _
    Public Sub Main()
        Dim strFile As String = Nothing
        Dim Fmt As Imaging.ImageFormat = Imaging.ImageFormat.Bmp
        Dim blnShowGui As Boolean = False

        blnShowGui = ShowGUI()
        If GetQuietOutput() Then mblnConsoleOut = False Else mblnConsoleOut = True

        If blnShowGui = False Then
            Writeline("")
            Writeline("WamPosterCL Created by: X 2004")
            Writeline("This application is freeware!")
            Writeline("-------------------------------")
        End If

        If Environment.GetCommandLineArgs.GetUpperBound(0) <= 0 Then
            Writeline("No Commend line arguments specified!")
            Writeline("")
            Writeline("/f:bmp -f:bmp    Saves image using windows bitmap format.")
            Writeline("/f:gif -f:gif    Saves image using compuserve graphics interchange format.")
            Writeline("/f:jpg -f:jpg    Saves image using JPEG format.")
            Writeline("/f:png -f:png    Saves image using portable network graphics format.")
            Writeline("/n:<file> -n:           Specifies the filename. EX: /n:test.jpg")
            Writeline("/c -c            Allows user to configure camera settings.")
            Writeline("/l -l            Lists availible/connected cameras.")
            Writeline("/s -s            Display saved camera settings.")
            Writeline("/t -t            Embed the time in the top left of the image.")
            Writeline("/d -d            Embed the date in the top left of the image.")
            Writeline("/td -td /dt -dt  Embed the date and time in the top left of the image.")
            Writeline("/g -g /gui -gui  Display graphical user interface.")
            Writeline("/1-9 -1-9        Specifies the position to embed the text.")
            Writeline("     1 = Top Left        2 = Top Center      3 = Top Right")
            Writeline("     4 = Left Center     5 = Center          6 = Right Center")
            Writeline("     7 = Bottom Left     8 = Bottom Center   9 = Bottom Right")
            Writeline("")
            Writeline("     For example: " & IO.Path.GetFileName(Application.ExecutablePath) & " /9 /d /f:jpg /n:test.jpg")
            Writeline("     Will embed the date in the bottom right corder of the image.")
            Writeline("/u -u            Upload image to ftp server. To setup FTP server login")
            Writeline("                 settings use /c or -c")
            Writeline("/q -q            Quiet running will not write anything to the console.")
            Writeline("")
            Writeline("NOTE: If no /f: parameter is speciied the image will be saved using")
            Writeline("      the bmp format regardless of the filename extention you give.")
            Writeline("")
        Else

            ' check if any cameras availible
            If GetListOfCameras() Is Nothing Then
                Dim Msg As String = "There are no cameras connected or availible for capturing!"
                If blnShowGui Then
                    Writeline(Msg)
                    Writeline("")
                Else
                    MsgBox(Msg, MsgBoxStyle.Information Or MsgBoxStyle.OKOnly)
                End If
                GoTo CleanUp
            End If

            ' check to show gui
            If blnShowGui Then
                Dim F As frmMain
                ' get camera
                If GetCameraName() Is Nothing Then
                    Dim Msg As String
                    msg = "No camera was specified or is availible!" & vbCrLf
                    msg &= "Make sure your camera is properly connected and setup!"
                    MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OKOnly)
                    Exit Sub
                End If

                F = New frmMain()
                F.ShowDialog()
                F.Dispose()
                F = Nothing
                GoTo CleanUp
            End If

            ' list availible cameras
            If ListAvailibleCameras() Then
                Writeline("")
                GoTo CleanUp
            End If

            ' list availible cameras
            If DisplayCameraSettings() Then
                Dim S As New Settings()
                Writeline("Camera: " & S.CameraName)
                Writeline("FPS: " & S.FPS.ToString)
                Writeline("Frame Size: " & S.FrameSize.Width.ToString & "x" & S.FrameSize.Height.ToString)
                S = Nothing

                Writeline("")
                GoTo CleanUp
            End If

            ' get camera
            If GetCameraName() Is Nothing Then
                Writeline("No camera was specified or is availible!")
                Writeline("Make sure your camera is properly connected and setup!")
                Writeline("")
                GoTo CleanUp
            End If

            ' configure camera capture settings to use
            Dim SChange As Boolean = False
            If ConfigCamera(SChange) Then
                If SChange Then
                    Writeline("Camera settings were changed!")
                Else
                    Writeline("No camera settings were changed.")
                End If
                Writeline("")
                GoTo CleanUp
            End If

            ' setup the camera for capturing
            SetupCamera()

            ' get the filename to use
            strFile = GetFileName()
            If strFile.Trim.Length = 0 Then
                Writeline("No filename specified!")
                Writeline("")
                GoTo CleanUp
            End If
            Writeline("Filename: " & strFile)

            ' get the format to use
            Fmt = GetFormat()
            Writeline("Format: " & Fmt.ToString)

            ' capture the image
            Writeline("Capturing...")
            CaptureImage()
            If mobjImage Is Nothing Then
                Writeline("... Could not capture image. File not saved.")
                GoTo CleanUp
            Else
                Dim S As New Settings()
                Dim TP As Integer
                TP = GetTextPosition()
                If TP = -1 Then TP = S.TextPosition
                If GetDateTime() Or (GetTime() And GetDate()) Then
                    AddText(mobjImage, True, True, CType(TP, ContentAlignment), Color.FromArgb(S.TextColor))
                ElseIf GetTime() Then
                    AddText(mobjImage, False, True, CType(TP, ContentAlignment), Color.FromArgb(S.TextColor))
                ElseIf GetDate() Then
                    AddText(mobjImage, True, False, CType(TP, ContentAlignment), Color.FromArgb(S.TextColor))
                End If

                If IO.File.Exists(strFile) Then IO.File.Delete(strFile)
                mobjImage.Save(strFile, Fmt)

                Writeline("... File Saved!")
            End If

            ' upload image to ftp
            If UploadImage() Then
                Writeline("Uploading image...")
                Dim Ret As Integer
                Ret = DoUpload(strFile)
                If Ret < 200 Or Ret > 299 Then
                    Writeline("... Upload Failed. FTP Code: " & Ret.ToString)
                    GoTo CleanUp
                Else
                    Writeline("... Upload successfull.")
                End If
            End If


            Writeline("Done.")
            Writeline("")
        End If

CleanUp:
        ' dispose of varibles
        If Not CaptureInformation.CaptureInfo Is Nothing Then CaptureInformation.CaptureInfo.Dispose()
        CaptureInformation.CaptureInfo = Nothing
        CaptureInformation.Camera = Nothing
        Dispositivos = Nothing

    End Sub

    Private Function UploadImage() As Boolean
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-u" Or Tmp = "/u" Then Return True
        Next

        Return False
    End Function

    Friend Function DoUpload(ByVal File As String) As Integer
        Dim FTP As New FtpConnection()
        Dim S As New Settings()
        Dim Ret As Integer

        ' for info about FTP code see http://www.ftpplanet.com/ftpresources/ftp_codes.htm
        Try
            ' setup logon info
            FTP.Hostname = S.FTPServer
            FTP.Username = S.UserName
            FTP.Password = S.Password
            ' setup passive ftp connection
            FTP.Passive = True
            ' attempt to connect to server
            FTP.Connect()
            Ret = FTP.GetLastResponseNumber
            If Ret < 200 Or Ret > 299 Then GoTo DoExit

            ' attempt to set remote path
            FTP.WorkDir = S.RemotePath
            Ret = FTP.GetLastResponseNumber
            If Ret < 200 Or Ret > 299 Then GoTo DoExit

            ' try to upload file
            FTP.UploadFile(File, IO.Path.GetFileName(File), FtpConnection.StreamModes.Binary)
            Ret = FTP.GetLastResponseNumber
            If Ret < 200 Or Ret > 299 Then GoTo DoExit

            ' now we can dissconnect
            FTP.Disconnect()
            Ret = FTP.GetLastResponseNumber
            If Ret < 200 Or Ret > 299 Then GoTo DoExit

        Catch ex As Exception
            'ERR: handle error?
        End Try

DoExit:
        S = Nothing
        FTP = Nothing
        Return Ret
    End Function

    Friend Sub AddText(ByVal I As Image, ByVal DateText As Boolean, ByVal TimeText As Boolean, ByVal TextPosition As ContentAlignment, ByVal TextColor As Color)
        Dim Msg As String
        Dim S As New Settings()

        If I Is Nothing Then Exit Sub

        Dim G As Graphics = Graphics.FromImage(I)

        If DateText And TimeText Then
            Msg = Now.ToLongTimeString & vbCrLf & Now.ToLongDateString
        ElseIf TimeText Then
            Msg = Now.ToLongTimeString
        ElseIf DateText Then
            Msg = Now.ToLongDateString
        End If

        Dim SF As New StringFormat()
        Select Case TextPosition
            Case ContentAlignment.BottomCenter
                SF.Alignment = StringAlignment.Center
                SF.LineAlignment = StringAlignment.Far

            Case ContentAlignment.BottomLeft
                SF.Alignment = StringAlignment.Near
                SF.LineAlignment = StringAlignment.Far

            Case ContentAlignment.BottomRight
                SF.Alignment = StringAlignment.Far
                SF.LineAlignment = StringAlignment.Far

            Case ContentAlignment.MiddleCenter
                SF.Alignment = StringAlignment.Center
                SF.LineAlignment = StringAlignment.Center

            Case ContentAlignment.MiddleLeft
                SF.Alignment = StringAlignment.Near
                SF.LineAlignment = StringAlignment.Center

            Case ContentAlignment.MiddleRight
                SF.Alignment = StringAlignment.Far
                SF.LineAlignment = StringAlignment.Center

            Case ContentAlignment.TopCenter
                SF.Alignment = StringAlignment.Center
                SF.LineAlignment = StringAlignment.Near

            Case ContentAlignment.TopLeft
                SF.Alignment = StringAlignment.Near
                SF.LineAlignment = StringAlignment.Near

            Case ContentAlignment.TopRight
                SF.Alignment = StringAlignment.Far
                SF.LineAlignment = StringAlignment.Near

        End Select

        Dim F As New FontFamily(Drawing.Text.GenericFontFamilies.Serif)
        Dim B As Brush = New SolidBrush(TextColor)
        Dim R As RectangleF
        R = New RectangleF(0, 0, I.Width, I.Height)
        G.DrawString(Msg, New Font(F, 16, FontStyle.Bold, GraphicsUnit.Pixel), B, R, SF)

        G.Dispose()
        G = Nothing
    End Sub

    Private Function ConfigCamera(ByRef SettingsChanged As Boolean) As Boolean
        Dim Tmp As String
        Dim idx As Integer
        Dim Args() As String


        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-c" Or Tmp = "/c" Then
                Dim CDlg As New frmConfig()
                CDlg.btnCamera.Text = GetCameraName()
                ' can't show dialog if there is no camera set or no cameras exist!
                SettingsChanged = False
                If Not CDlg.btnCamera.Text Is Nothing Then

                    CDlg.SetupCam()
                    CDlg.TopMost = True
                    If CDlg.ShowDialog = DialogResult.OK Then
                        SettingsChanged = True
                    Else
                        SettingsChanged = False
                    End If
                End If
                CDlg.Dispose()
                CDlg = Nothing
                Return True
            End If
        Next

        Return False
    End Function

    Private Function ListAvailibleCameras() As Boolean
        Dim Tmp As String
        Dim idx As Integer
        Dim Args() As String


        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-l" Or Tmp = "/l" Then
                Dim List() As String
                Dim idy As Integer

                List = GetListOfCameras()
                If List Is Nothing Then
                    Writeline("There are no availible or connected cameras.")
                    Return True
                End If

                For idy = 0 To List.Length - 1
                    Writeline(idy.ToString & ": " & List(idy))
                Next

                Return True
            End If
        Next

        Return False
    End Function

    Private Function DisplayCameraSettings() As Boolean
        Dim Tmp As String
        Dim idx As Integer
        Dim Args() As String


        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-s" Or Tmp = "/s" Then Return True
        Next

        Return False
    End Function

    Friend Function SetCamera() As String
        Dim CamName As String = Nothing

        Try
            Dim AddCamera As New frmAddCam()
            AddCamera.TopMost = True
            If AddCamera.ShowDialog() = DialogResult.OK Then
                CamName = AddCamera.GetSelectedCameraName

                CaptureInformation.Camera = Nothing
                If Not CaptureInformation.CaptureInfo Is Nothing Then
                    CaptureInformation.CaptureInfo.PreviewWindow = Nothing
                    CaptureInformation.CaptureInfo.Dispose()
                End If
                CaptureInformation.CaptureInfo = Nothing

                CaptureInformation.Camera = Dispositivos.VideoInputDevices(AddCamera.GetSelectedCameraIndex)
                CaptureInformation.CaptureInfo = New Capture(CaptureInformation.Camera, Nothing)
            End If

            AddCamera.Dispose()
            AddCamera = Nothing

        Catch ex As Exception
            'ERR: handle error?
            Return Nothing
        End Try

        If CamName Is Nothing Then Return Nothing

        ' save camera name
        Dim S As New Settings()
        S.CameraName = CamName
        S = Nothing

        Return CamName
    End Function

    Friend Function GetCameraName() As String
        Dim CamName As String = Nothing

        Dim S As New Settings()

        CamName = S.CameraName
        If CamName Is Nothing Then Return SetCamera()
        If CamName.Length = 0 Then Return SetCamera()
        Try
            ' try to find camera
            Dim idx As Integer
            For idx = 0 To Dispositivos.VideoInputDevices.Count - 1
                If Dispositivos.VideoInputDevices(idx).Name = CamName Then
                    CaptureInformation.Camera = Nothing
                    If Not CaptureInformation.CaptureInfo Is Nothing Then
                        CaptureInformation.CaptureInfo.PreviewWindow = Nothing
                        CaptureInformation.CaptureInfo.Dispose()
                    End If
                    CaptureInformation.CaptureInfo = Nothing

                    CaptureInformation.Camera = Dispositivos.VideoInputDevices(idx)
                    CaptureInformation.CaptureInfo = New Capture(CaptureInformation.Camera, Nothing)
                    GoTo DoExit
                End If
            Next
            CamName = Nothing

        Catch ex As Exception
            CamName = Nothing
        End Try


DoExit:
        S = Nothing
        Return CamName
    End Function

    Friend Function GetListOfCameras() As String()
        Dim list() As String = Nothing

        Dim idx As Integer

        If Dispositivos.VideoInputDevices.Count = 0 Then Return Nothing
        ReDim list(Dispositivos.VideoInputDevices.Count - 1)

        'Add to cboCamaras available cameras
        For idx = 0 To Dispositivos.VideoInputDevices.Count - 1
            list(idx) = Dispositivos.VideoInputDevices(idx).Name
        Next

        Return list
    End Function

    Friend Sub SetupCamera()
        Dim S As New Settings()

        ' Change the compressor
        CaptureInformation.CaptureInfo.VideoCompressor = Nothing 'Dispositivos.VideoCompressors(0)

        ' Change the image size
        CaptureInformation.CaptureInfo.FrameSize = S.FrameSize

        ' Change the number of frames per second
        CaptureInformation.CaptureInfo.FrameRate = S.FPS

        S = Nothing
    End Sub

    Private Function GetFormat() As Imaging.ImageFormat
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-f:bmp" Or Tmp = "/f:bmp" Then Return Imaging.ImageFormat.Bmp
            If Tmp = "-f:gif" Or Tmp = "/f:gif" Then Return Imaging.ImageFormat.Gif
            If Tmp = "-f:jpg" Or Tmp = "/f:jpg" Then Return Imaging.ImageFormat.Jpeg
            If Tmp = "-f:png" Or Tmp = "/f:png" Then Return Imaging.ImageFormat.Png
        Next

        Return Imaging.ImageFormat.Bmp
    End Function

    Private Function GetTextPosition() As Integer
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            Select Case Tmp
                Case "/1", "-1"
                    Return ContentAlignment.TopLeft

                Case "/2", "-2"
                    Return ContentAlignment.TopCenter

                Case "/3", "-3"
                    Return ContentAlignment.TopRight

                Case "/4", "-4"
                    Return ContentAlignment.MiddleLeft

                Case "/5", "-5"
                    Return ContentAlignment.MiddleCenter

                Case "/6", "-6"
                    Return ContentAlignment.MiddleRight

                Case "/7", "-7"
                    Return ContentAlignment.BottomLeft

                Case "/8", "-8"
                    Return ContentAlignment.BottomCenter

                Case "/9", "-9"
                    Return ContentAlignment.BottomRight

            End Select
        Next

        Return -1
    End Function

    Private Function GetDateTime() As Boolean
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-dt" Or Tmp = "/dt" Or Tmp = "-td" Or Tmp = "/td" Then Return True
        Next

        Return False
    End Function

    Private Function ShowGUI() As Boolean
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-g" Or Tmp = "/g" Or Tmp = "-gui" Or Tmp = "/gui" Then Return True
        Next

        Return False
    End Function

    Private Function GetDate() As Boolean
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-d" Or Tmp = "/d" Then Return True
        Next

        Return False
    End Function

    Private Function GetQuietOutput() As Boolean
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-q" Or Tmp = "/q" Then Return True
        Next

        Return False
    End Function

    Private Function GetTime() As Boolean
        Dim idx As Integer
        Dim Tmp, Args() As String

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            If Tmp = "-t" Or Tmp = "/t" Then Return True
        Next

        Return False
    End Function

    Private Function GetFileName() As String
        Dim Tmp As String
        Dim idx As Integer
        Dim Args() As String
        Dim strFile As String = String.Empty
        Dim blnAppendParts As Boolean = False

        Args = Environment.GetCommandLineArgs
        For idx = Args.GetLowerBound(0) + 1 To Args.GetUpperBound(0)
            Tmp = Args(idx).ToLower
            ' filename may contin spaces
            If (Tmp.Substring(0, 1) = "-" Or Tmp.Substring(0, 1) = "/") And blnAppendParts Then
                strFile &= Tmp
            Else
                If Tmp.Length > 3 Then
                    If Tmp.Substring(0, 3) = "-n:" Or Tmp.Substring(0, 3) = "/n:" Then
                        strFile = Tmp.Substring(3)
                        blnAppendParts = True
                    End If
                End If
            End If
        Next

        Return strFile
    End Function

    Private Sub CaptureImage()
        Dim Frm As New Form()
        Frm.Size = New Size(640, 480)
        Frm.FormBorderStyle = FormBorderStyle.None
        Frm.StartPosition = FormStartPosition.CenterScreen
        Dim P As New Panel()
        P.Size = New Size(640, 480)
        Frm.Controls.Add(P)
        P.Show()

        mobjDelayTimer = New Timer()
        mobjDelayTimer.Interval = 2000
        AddHandler mobjDelayTimer.Tick, AddressOf TimerTick

        CaptureInformation.CaptureInfo.PreviewWindow = P
        AddHandler CaptureInformation.CaptureInfo.FrameCaptureComplete, AddressOf RefreshImage

        ' capture once to warm up camera
        Try
            CaptureInformation.CaptureInfo.CaptureFrame()
        Catch ex As Exception
            'ERR: handle error? 
        End Try

        ' wait a sec for cam to warm up
        mobjDelayTimer.Start()
        While mobjDelayTimer.Enabled
            Application.DoEvents()
        End While

        ' now capture the image from the camera
        Try
            CaptureInformation.CaptureInfo.CaptureFrame()
        Catch ex As Exception
            'ERR: handle error?
            GoTo CleanUp
        End Try

        mobjDelayTimer.Start()
        While mobjDelayTimer.Enabled
            Application.DoEvents()
        End While

CleanUp:
        RemoveHandler CaptureInformation.CaptureInfo.FrameCaptureComplete, AddressOf RefreshImage
        Frm.Dispose()
        Frm = Nothing

        RemoveHandler mobjDelayTimer.Tick, AddressOf TimerTick
        mobjDelayTimer.Dispose()
        mobjDelayTimer = Nothing
    End Sub

    Private Sub RefreshImage(ByVal Frame As System.Windows.Forms.PictureBox)
        mobjImage = Frame.Image
    End Sub

    Private Sub TimerTick(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjDelayTimer.Stop()
    End Sub
End Module
