'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: June 15, 2004
'=============================================

Public Class Settings

#Region " Get/Set values ... "
    Private Function GetValue(ByVal KeyName As String, ByVal DefaultValue As String) As String
        Dim Key As Microsoft.Win32.RegistryKey
        Try
            Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(KEYPATH)
        Catch ex As Exception
            Return DefaultValue
        End Try

        If Key Is Nothing Then Return DefaultValue

        Dim Value As String
        Try
            Value = Convert.ToString(Key.GetValue(KeyName, DefaultValue))
        Catch ex As Exception
            Return DefaultValue
        End Try

        Return Value
    End Function

    Private Function SetValue(ByVal KeyName As String, ByVal Value As String) As Boolean
        Dim Key As Microsoft.Win32.RegistryKey
        Try
            Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(KEYPATH, True)
        Catch ex As Exception
            Try
                Key = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(KEYPATH)
            Catch exx As Exception
                Return False
            End Try

            Return False
        End Try

        If Key Is Nothing Then
            Try
                Key = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(KEYPATH)
            Catch exx As Exception
                Return False
            End Try

            Return False
        End If

        Try
            Key.SetValue(KeyName, Value)
        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function

    Private Function GetValue(ByVal KeyName As String, Optional ByVal DefaultValue As Integer = -1) As Integer
        Dim Key As Microsoft.Win32.RegistryKey
        Try
            Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(KEYPATH)
        Catch ex As Exception
            Return DefaultValue
        End Try

        If Key Is Nothing Then Return DefaultValue

        Dim Value As Integer
        Try
            Value = Convert.ToInt32(Key.GetValue(KeyName, DefaultValue))
        Catch ex As Exception
            Return DefaultValue
        End Try

        Return Value
    End Function

    Private Function SetValue(ByVal KeyName As String, ByVal Value As Integer) As Boolean
        Dim Key As Microsoft.Win32.RegistryKey
        Try
            Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(KEYPATH, True)
        Catch ex As Exception
            Try
                Key = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(KEYPATH)
            Catch exx As Exception
                Return False
            End Try

            Return False
        End Try

        If Key Is Nothing Then
            Try
                Key = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(KEYPATH)
            Catch exx As Exception
                Return False
            End Try

            Return False
        End If
       
        Try
            Key.SetValue(KeyName, Value)
        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function
#End Region


    Public Property FTPServer() As String
        Get
            Return GetValue("FTPServer", String.Empty)
        End Get
        Set(ByVal Value As String)
            SetValue("FTPServer", Value)
        End Set
    End Property

    Public Property RemotePath() As String
        Get
            Return GetValue("RemotePath", String.Empty)
        End Get
        Set(ByVal Value As String)
            SetValue("RemotePath", Value)
        End Set
    End Property

    Public Property UserName() As String
        Get
            Return GetValue("UserName", String.Empty)
        End Get
        Set(ByVal Value As String)
            SetValue("UserName", Value)
        End Set
    End Property

    Public Property Password() As String
        Get
            Dim Ret As String = GetValue("Password", String.Empty)
            Return Decode(Ret)
        End Get
        Set(ByVal Value As String)
            SetValue("Password", Encode(Value))
        End Set
    End Property

    Private Function Encode(ByVal Value As String) As String
        Dim idx As Integer
        Dim Tmp() As Byte
        If Value.Length < 4 Then Return Value
        ReDim Tmp(Value.Length - 1)
        For idx = 0 To Value.Length - 1
            Dim I As Byte
            I = Convert.ToByte(Value.Chars(idx))
            Tmp(idx) = I
        Next
        Return Convert.ToBase64String(Tmp)
    End Function

    Private Function Decode(ByVal Value As String) As String
        If Value.Length < 4 Then Return Value
        Dim idx As Integer
        Dim Tmp() As Byte = Convert.FromBase64String(Value)
        Dim Ret As String

        For idx = 0 To Tmp.Length - 1
            Ret &= Convert.ToChar(Tmp(idx))
        Next

        Return Ret
    End Function

    Public Property CameraName() As String
        Get
            Return GetValue("CameraName", String.Empty)
        End Get
        Set(ByVal Value As String)
            SetValue("CameraName", Value)
        End Set
    End Property

    Public Property FPS() As Integer
        Get
            Return GetValue("FPS", 30)
        End Get
        Set(ByVal Value As Integer)
            SetValue("FPS", Value)
        End Set
    End Property

    Public Property TextColor() As Integer
        Get
            Return GetValue("TextColor", Color.White.ToArgb)
        End Get
        Set(ByVal Value As Integer)
            SetValue("TextColor", Value)
        End Set
    End Property

    Public Property EmbedDate() As Integer
        Get
            Return GetValue("EmbedDate", 0)
        End Get
        Set(ByVal Value As Integer)
            SetValue("EmbedDate", Value)
        End Set
    End Property

    Public Property EmbedTime() As Integer
        Get
            Return GetValue("EmbedTime", 0)
        End Get
        Set(ByVal Value As Integer)
            SetValue("EmbedTime", Value)
        End Set
    End Property

    Public Property TextPosition() As Drawing.ContentAlignment
        Get
            Return CType(GetValue("EmbedTime", Drawing.ContentAlignment.TopLeft), Drawing.ContentAlignment)
        End Get
        Set(ByVal Value As Drawing.ContentAlignment)
            SetValue("EmbedTime", Value)
        End Set
    End Property

    Public Property FrameSize() As Size
        Get
            Dim S As Size
            S.Width = GetValue("FrameWidth", 640)
            S.Height = GetValue("FrameHeight", 480)
            Return S
        End Get
        Set(ByVal Value As Size)
            SetValue("FrameWidth", Value.Width)
            SetValue("FrameHeight", Value.Height)
        End Set
    End Property
End Class